

function ___$insertStyle(css) {
    if (!css || typeof window === 'undefined') {
        return;
    }
    const style = document.createElement('style');
    style.setAttribute('type', 'text/css');
    style.innerHTML = css;
    document.head.appendChild(style);
    return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

var index$1 = require('./index-7e49c42e.js');
var index = require('./index-3ade7882.js');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = index$1.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = index$1.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return index$1.possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Checkbox = /*#__PURE__*/function (_PureComponent) {
  index$1.inherits(Checkbox, _PureComponent);
  var _super = _createSuper(Checkbox);
  function Checkbox(props) {
    var _this;
    index$1.classCallCheck(this, Checkbox);
    _this = _super.call(this, props);
    index.defineProperty(index$1.assertThisInitialized(_this), "onChange", function () {
      var _this$props = _this.props,
        trackValue = _this$props.trackValue,
        activeProps = _this$props.active,
        disabled = _this$props.disabled;
      if (disabled) return;
      if (trackValue) {
        _this.props.onChange(_this.state.active);
        return;
      }
      _this.setState(function (prevState) {
        var active = trackValue ? activeProps : !prevState.active;
        if (_this.props.type === 'radio') {
          active = true;
        }
        return {
          active: active
        };
      }, function () {
        _this.props.onChange(_this.state.active);
      });
    });
    index.defineProperty(index$1.assertThisInitialized(_this), "active", function (active) {
      _this.setState({
        active: active
      });
    });
    _this.active = _this.active.bind(index$1.assertThisInitialized(_this));
    _this.state = {
      active: props.active
    };
    return _this;
  }
  index$1.createClass(Checkbox, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var classNames = this.props.type;
      if (this.state.active) classNames += ' active';
      if (this.props.classNames.length) classNames += " ".concat(this.props.classNames);
      if (this.props.disabled) classNames += ' disabled';
      return /*#__PURE__*/React__default["default"].createElement("div", {
        title: this.props.title,
        className: classNames,
        disabled: this.props.disabled,
        onClick: function onClick() {
          _this2.onChange();
        }
      }, this.props.children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var active = nextProps.active,
        trackValue = nextProps.trackValue;
      if ((trackValue || nextProps.type === 'radio') && active !== prevState.active) {
        return {
          active: active
        };
      }
      return null;
    }
  }]);
  return Checkbox;
}(React.PureComponent);
index.defineProperty(Checkbox, "defaultProps", {
  classNames: '',
  title: '',
  type: 'checkbox',
  active: false,
  disabled: false,
  trackValue: false
});
index.defineProperty(Checkbox, "propTypes", {
  onChange: index$1.propTypes.func.isRequired,
  classNames: index$1.propTypes.string,
  type: index$1.propTypes.string,
  title: index$1.propTypes.string,
  active: index$1.propTypes.bool,
  disabled: index$1.propTypes.bool,
  trackValue: index$1.propTypes.bool
});
Checkbox.displayName = "Checkbox";

exports["default"] = Checkbox;
